#ifndef _UNIFORM_PER_FRAME_CONSTANTS_H
#define _UNIFORM_PER_FRAME_CONSTANTS_H

#include "uniformMacro.h"

#ifdef MCPE_PLATFORM_NX
layout(binding = 2) uniform PerFrameConstants {
#endif
// BEGIN_UNIFORM_BLOCK(PerFrameConstants) - unfortunately this macro does not work on old Amazon platforms so using above 3 lines instead
UNIFORM vec3 VIEW_POS;
UNIFORM highp float TIME;
UNIFORM vec4 FOG_COLOR;
UNIFORM vec2 FOG_CONTROL;
UNIFORM float RENDER_DISTANCE;
UNIFORM float FAR_CHUNKS_DISTANCE;
END_UNIFORM_BLOCK

#endif

vec3 uc(vec3 x, float P, float a, float m, float l, float c, float b) { 
float l0 = ((P - m) * l) / a; 
float L0 = m - m / a; 
float L1 = m + (1.0 - m) / a; 
float S0 = m + l0; 
float S1 = m + a * l0; 
float C2 = (a * P) / (P - S1); 
float CP = -C2 / P; 

vec3 w0 = vec3(1.0 - smoothstep(0.0, m, x)); 
vec3 w2 = vec3(step(m + l0, x)); 
vec3 w1 = vec3(1.0 - w0 - w2); 
vec3 T = vec3(m * pow(x / m, vec3(c)) + b); 
vec3 S = vec3(P - (P - S1) * exp(CP * (x - S0))); 
vec3 L = vec3(m + a * (x - m)); 
return T * w0 + L * w1 + S * w2;} 

vec3 uc(vec3 x) { 
const float P = 0.75; // max display brightness 
const float a = 0.8; // contrast 
const float m = 0.22; // linear section start 
const float l = 0.4; // linear section length 
const float c = 1.74; // black 
const float b = 0.0; // pedestal 
return uc(x, P, a, m, l, c, b);}


float ac(float x) {
float A = 3.5;
float B = 0.05;
float C = 3.55;
float D = 3.85;
float E = 0.05;
float F = 0.35;
return ((x * (A * x + C * B) + D * E) / (x * (A * x + B) + D * F)) - E / F;
}

vec3 ic(vec3 clr) {
float W = 1.3 / 1.0;
float Luma = dot(clr, vec3(0.0, 0.3, 0.3));
vec3 Chroma = clr - Luma;
clr = (Chroma * 1.70) + Luma;
clr = vec3(ac(clr.r), ac(clr.g), ac(clr.b)) / ac(W);
return clr;
}